<script lang="ts">
	import { newProductTypes, newProductList } from '../../../../utils/utils';
	import { store_footerHeight, store_screenWidth } from '../../../../utils/store';
	import ProductCategory from './ProductCategory.svelte';
	import type { Category, ProductFB } from '../../../(admin)/admin/produits/type';
	import { collection, getDocs, query, where } from 'firebase/firestore';
	import { db } from '$lib/firebase/firebase';
	import { onMount } from 'svelte';

	let categories: Category[] = [];
	const getCategories = async () => {
		categories = [];
		const docRef = await getDocs(collection(db, 'categories'));
		docRef.forEach((doc) => {
			categories.push({ ...doc.data(), id: doc.id } as Category);
		});
		categories = categories;
		categories.sort((a, b) => a.order - b.order);
	};

	const getProducts = async (category: Category): Promise<ProductFB[]> => {
		let categoryProducts: ProductFB[] = [];
		const q = query(collection(db, 'products'), where('categoryId', '==', category.id));
		const querySnapshot = await getDocs(q);
		querySnapshot.forEach((doc) => {
			categoryProducts.push({ ...doc.data(), id: doc.id } as ProductFB);
			categoryProducts = categoryProducts;
		});
		return categoryProducts;
	};

	let productsByCategory: [
		{
			category: Category;
			products: ProductFB[];
		}
	][] = [];

	onMount(async () => {
		await getCategories();
		if (categories.length > 0) {
			const promises = categories.map(async (category) => {
				const prods = await getProducts(category);
				return {
					category: category,
					products: prods
				};
			});

			productsByCategory = await Promise.all(promises);
		}
	});

	let divStyle = '';
	$: if ($store_screenWidth <= 768) {
		divStyle = 'padding-bottom: ' + ($store_footerHeight + 20) + 'px;';
	}
</script>

<div class="md:mb-0 pb-12">
	{#if productsByCategory?.length > 0}
		{#each productsByCategory as productType, index}
			<ProductCategory {index} {productType} products={productType.products} />
		{/each}
	{/if}
</div>
